#define wait_ms(t) (ThisThread::sleep_for(chrono::milliseconds(t)))
#define BPS         9600

#ifndef __TYPEDEFINE_H
#define __TYPEDEFINE_H

#define GOIPL       0x2000
#define SECT_SIZE   128
#define SECT_CNT    64      // CP/M sector size.
#define BLOCK_SIZE  2048    // CP/M block size.

#define SZRING      128
#define CTRLC       0x03
#define LF          0x0a
#define CR          0x0d
#define BS          0x08
#define STX         0x02
#define ETX         0x03
#define CMD_BOOT    0x03
#define CMD_WBOOT   0x04
#define CMD_SEEK    0x05
#define CMD_DMARD   0x06
#define CMD_DMAWR   0x07

#define  TRACK_SEL_L  0xA0
#define  TRACK_SEL_H  0xA1
#define  SECTOR_SEL   0xA2
#define  ADR_L        0xA4
#define  ADR_H        0xA5
#define  EXEC_DMA     0xA6
#define  DMA_RS       0xA7

//#define _BIG_ENDIAN
//#define DBG01
#define CONSTS      0x80    //2014.4.20
#define  CONIN      0x81
#define  CONOUT     0x82
#define  SIOAD      0x18
#define  SIOAC      0x19
#define  SIOBD      0x1A
#define  SIOBC      0x1B

#define Z80_MEM_SIZE    0x10000      // 64kbyte
/*----------------------------------------------------------------------*/
/*                                                                      */
/*----------------------------------------------------------------------*/
typedef unsigned char    uchar;
typedef unsigned short    ushort;
typedef unsigned int    uint;
typedef    unsigned long    ulong;

typedef    volatile char    vchar;
typedef    volatile short  vshort;
typedef    volatile int    vint;
typedef    volatile long    vlong;

typedef    volatile unsigned char    vuchar;
typedef    volatile unsigned short    vushort;
typedef    volatile unsigned int    vuint;
typedef    volatile unsigned long    vulong;


// bz80
typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned long uint32;
typedef signed char int8;
typedef signed short int16;
typedef signed long int32;
#endif
