/*
   mbed NUCLEO-F401RE cpm80
   ram size 0000 - FFFFH
*/
#include "mbed.h"
#include "define.h"
#include <string>

//------------------------------------------------------------
class Serial{
private:
	UnbufferedSerial sp;
public:
	Serial(PinName, PinName);
	void baud(int);
	bool readable(void);
	bool writeable(void);
	char getc(void);
	void putc(char);
	void puts(const char*);
	void printf(const char*);
};

Serial::Serial(PinName tx, PinName ty)
: sp(tx, ty) {
}

void Serial::baud(int b)
{
	sp.baud(b);
}

bool Serial::readable(void)
{
	return sp.readable();
}

bool Serial::writeable(void)
{
	return sp.writeable();
}

char Serial::getc(void)
{
    char c;
    sp.read(&c, 1);
	return c;
}

void Serial::putc(char c)
{
	sp.write(&c, 1);
}

void Serial::puts(const char* s)
{
    std::string str = s;
	sp.write(s, str.length());
}

void Serial::printf(const char* s)
{
    std::string str = s;
	sp.write(s, str.length());
}
//----------------------------------------------------------------------

Serial pc(USBTX, USBRX);

char b;
DigitalOut myled(LED1);

extern void Z80Run();
extern void setup();
extern void loop();
/*----------------------------------------------------------------------*/
short RecvZ80( void )
{
    if( pc.readable() ) {
        return pc.getc();
        return b;
    } else {
        return -1;  // empty
    }
}
/*-------------------------------------------*/
void  SendZ80( char data )
{
    while( !pc.writeable() );
    pc.putc( data );
}
/*-------------------------------------------*/
void WSendZ80( const char *data )
{
    while( *data ) {
        SendZ80( *data++ );
    }
}
/*-------------------------------------------*/
short BusySioZ80( void )
{
    if( pc.readable() ) { 
        return 0;
    } else {
        return -1;
    }

}
void OutLedZ80( uint8 data ) {
    if( data & 0x01 )  myled = 1;
    else               myled = 0;
}
void OutPutcZ80(char c) {
    pc.putc(c);
}
void delayZ80(int ms){
    wait_ms(ms);
}
void intro(void){
    pc.puts("\n\rCP/M80 emulator for mbed STM32 Nucleo.\r\n");
    pc.puts("originated from MAME Z80.\r\n");
    pc.puts("Takeda.Toshiya (CP/M Player) 2004.03.05\r\n");
    pc.puts("Y.ABE     (Abz80 mbed/RX62N) 2011.04.29\r\n");
    pc.puts("mosaku        (mbed/arduino) 2014.04.12\r\n");
    pc.puts("neko Java         (mbed-os6) 2023.03.30\r\n\r\n");
}
/*-------------------------------------------*/
int main() {
    wait_ms(100);
    pc.baud( BPS );
    intro();
    setup();
    while (true) { Z80Run(); }
}
